{
  "x-generator": "NSwag v14.6.1.0 (NJsonSchema v11.5.1.0 (Newtonsoft.Json v13.0.0.0))",
  "openapi": "3.0.0",
  "info": {
    "title": "inMobile REST API",
    "description": "\n# Introduction\n\nThis document is a technical description of our REST API used for external systems to send SMS and Email messages, retrieve SMS statuses and Email events, and maintain lists and blacklists.\n\nIn order to call our API, you need an api key. Log in to your account at <a href=\"https://app.inmobile.com/\" target=\"_blank\" rel=\"noopener noreferrer\">https://app.inmobile.com/</a>, go to the \"API\" menu section and your api key will be available here.\n\nNOTE: It is required for clients to support tls 1.2 or higher.\n\n# Firewall opening\n\nThis is relevant for status callbacks and incoming SMS messages.\n\nYou can expect callbacks from one of the following IP ranges:\n\n* 46.36.205.80/28\n* 185.221.37.96/28\n\nThese are also the IP addresses which will be used for api.inmobile.com and app.inmobile.com - ensure access to these 2 ranges are opened in your firewall.\n\n# Status page\n\nA status page is available at <a href=\"https://status.inmobile.com/\" target=\"_blank\" rel=\"noopener noreferrer\">https://status.inmobile.com/</a>. You can subscribe to updates by clicking \"Get updates\", selecting \"Subscribe to specific components\", and choosing the components relevant to your integration, such as \"inMobile API\". When we replace old SSL certificates, updates are announced on the status page to subscribers of the \"SSL certificate\" component.\n\n# SMS\n\nSMS endpoints allow you to send text messages, retrieve message statuses, receive status callbacks, and handle incoming SMS messages. Lists and blacklists can also be maintained through the API to help manage recipients and opt-outs.\n\n# RCS\n\nTo use RCS, an RCS agent is required. You can set up and manage RCS agents by logging in to <a href=\"https://app.inmobile.com/\" target=\"_blank\" rel=\"noopener noreferrer\">https://app.inmobile.com/</a> and navigating to Settings -> RCS agents.\n\nRCS depends on a third party, Google, which means breaking changes can occur. We will do everything we can to avoid breaking changes, but if they become necessary, we will inform you ahead of time.\n\nYou can sign up for API updates on <a href=\"https://status.inmobile.com/\" target=\"_blank\" rel=\"noopener noreferrer\">https://status.inmobile.com/</a>. Click \"Get updates\", check \"Subscribe to specific components\", and make sure \"inMobile API\" is checked.\n\n## Message traffic type\nThe message traffic type is used to indicate the type of message being sent. The traffic type must be set to a value supported by the RCS agents use case.\n| Traffic type    | Description                                                                                                                                                                | Agent use case                             |\n|-----------------|----------------------------------------------------------------------------------------------------------------------------------------------------------------------------|--------------------------------------------|\n| Authentication  | For authentication messages                                                                                                                                                | OTP                                        |\n| Transaction     | For messages about a recipient's existing services or products, such as payment receipts or order confirmations.                                                           | Transactional, MultiUse                   |\n| Promotion       | For promotional messages, like offers, discounts and announcements.                                                                                                        | Promotional, MultiUse                     |\n| ServiceRequest  | For updates and information about services, that the recipient has requested.                                                                                              | OTP, Transactional, Promotional, MultiUse |\n| Acknowledgement | For messages to acknowledge a recipient's action. Specifically, unsubscribe requests. Used to confirm to the recipient that the request is received and is being processed.  | OTP, Transactional, Promotional, MultiUse |\n\nIf no message traffic type is specified, a default value is used, based on the agent use case.\n| Agent use case | Default message traffic type  |\n|----------------|-------------------------------|\n| OTP            | Authentication                |\n| Transactional  | Transaction                   |\n| Promotional    | Promotion                     |\n| MultiUse      | MessageTrafficTypeUnspecified |\n\n<b>MultiUse agents</b> do not have a default message traffic type. If no message traffic type is specified, the message will be rejected.\n\n# Email\n\nEmail endpoints allow you to send email messages through the API. Email events can be retrieved with the GET email events endpoint to keep your own system updated as messages are processed and delivered.\n\n# Webhook request signatures\n\nWebhook requests can be signed so you can verify that the request was sent by InMobile and that the request body was not changed in transit.\n\nYou can set up and view webhook signing key by logging in to your account at <a href=\"https://app.inmobile.com\" target=\"_blank\" rel=\"noopener noreferrer\">https://app.inmobile.com</a>, go to the \"Settings\" menu section, select the \"Security\" link and then the \"Webhook signing keys\" tab.\n\nThe signature headers are only added when your account has at least one webhook signing key. If no keys have been created, webhook requests are sent without these headers.\n\nSigned webhook requests include these HTTP headers:\n\n* `X-Inmobile-Signature-Version` - signature format version. The current version is `1`.\n* `X-Inmobile-Request-Timestamp` - UTC timestamp formatted as `yyyy-MM-dd'T'HH:mm:ss'Z'`.\n* `X-Inmobile-Request-Id` - unique request id used as part of the signed payload.\n* `X-Inmobile-Signature-KeyId` - id of the public key that should be used to validate the signature.\n* `X-Inmobile-Signature` - Base64 encoded ECDSA signature.\n\nTo validate a signed webhook request:\n\n1. Find the public key matching `X-Inmobile-Signature-KeyId` in the webhook signing keys page.\n2. Build the signed payload by concatenating `X-Inmobile-Request-Id`, `X-Inmobile-Request-Timestamp`, and the raw request body exactly as received.\n3. Validate `X-Inmobile-Signature` against that payload with the public key using ECDSA P-256 with SHA-256.\n\nWe recommend rejecting requests with an invalid signature, requests where `X-Inmobile-Request-Timestamp` is older than 5 minutes, and duplicate request ids to protect against replay attacks.\n\nBelow are examples of how to validate webhook requests in different languages.\nThe examples assume that `publicKeyBase64` is the public key from the webhook signing keys page, and that `rawBody` is the unmodified request body exactly as received.\n\n## .NET\n\nMinimum version: .NET 5 with C# 8.\n\n```csharp\nusing System.Globalization;\nusing System.Security.Cryptography;\nusing System.Text;\n\nstatic bool IsValidInmobileWebhook(IDictionary<string, string> headers, string rawBody, string publicKeyBase64)\n{\n    var timestampText = headers[\"X-Inmobile-Request-Timestamp\"];\n    if (!DateTimeOffset.TryParseExact(\n            timestampText,\n            \"yyyy-MM-dd'T'HH:mm:ss'Z'\",\n            CultureInfo.InvariantCulture,\n            DateTimeStyles.AssumeUniversal | DateTimeStyles.AdjustToUniversal,\n            out var timestamp))\n        return false;\n\n    if (DateTimeOffset.UtcNow - timestamp > TimeSpan.FromMinutes(5))\n        return false;\n\n    var payload = headers[\"X-Inmobile-Request-Id\"] + timestampText + rawBody;\n    var signature = Convert.FromBase64String(headers[\"X-Inmobile-Signature\"]);\n\n    using var publicKey = ECDsa.Create();\n    publicKey.ImportSubjectPublicKeyInfo(Convert.FromBase64String(publicKeyBase64), out _);\n\n    return publicKey.VerifyData(\n        Encoding.UTF8.GetBytes(payload),\n        signature,\n        HashAlgorithmName.SHA256,\n        DSASignatureFormat.Rfc3279DerSequence);\n}\n```\n\n## PHP\n\nMinimum version: PHP 7.0 with the OpenSSL extension enabled.\n\n```php\nfunction isValidInmobileWebhook(array $headers, string $rawBody, string $publicKeyBase64): bool\n{\n    $timestampText = $headers['X-Inmobile-Request-Timestamp'];\n    $timestamp = DateTimeImmutable::createFromFormat(\n        '!Y-m-d\\TH:i:s\\Z',\n        $timestampText,\n        new DateTimeZone('UTC'));\n\n    if ($timestamp === false) {\n        return false;\n    }\n\n    if ((time() - $timestamp->getTimestamp()) > 300) {\n        return false;\n    }\n\n    $payload = $headers['X-Inmobile-Request-Id'] . $timestampText . $rawBody;\n    $publicKeyPem = \"-----BEGIN PUBLIC KEY-----\\n\"\n        . chunk_split($publicKeyBase64, 64, \"\\n\")\n        . \"-----END PUBLIC KEY-----\\n\";\n\n    return openssl_verify(\n        $payload,\n        base64_decode($headers['X-Inmobile-Signature'], true),\n        $publicKeyPem,\n        OPENSSL_ALGO_SHA256) === 1;\n}\n```\n\n## Python\n\nMinimum version: Python 3.9 with the `cryptography` package installed.\n\n```python\nfrom base64 import b64decode\nfrom datetime import datetime, timezone, timedelta\nfrom cryptography.exceptions import InvalidSignature\nfrom cryptography.hazmat.primitives import hashes, serialization\nfrom cryptography.hazmat.primitives.asymmetric import ec\n\ndef is_valid_inmobile_webhook(headers: dict[str, str], raw_body: bytes, public_key_base64: str) -> bool:\n    timestamp_text = headers[\"X-Inmobile-Request-Timestamp\"]\n    try:\n        timestamp = datetime.strptime(timestamp_text, \"%Y-%m-%dT%H:%M:%SZ\").replace(tzinfo=timezone.utc)\n    except ValueError:\n        return False\n\n    if datetime.now(timezone.utc) - timestamp > timedelta(minutes=5):\n        return False\n\n    payload = headers[\"X-Inmobile-Request-Id\"].encode() + timestamp_text.encode() + raw_body\n    public_key = serialization.load_der_public_key(b64decode(public_key_base64))\n\n    try:\n        public_key.verify(\n            b64decode(headers[\"X-Inmobile-Signature\"]),\n            payload,\n            ec.ECDSA(hashes.SHA256()))\n        return True\n    except InvalidSignature:\n        return False\n```\n\n## Node.js\n\nMinimum version: Node.js 14.13.1 using ES modules.\n\n```js\nimport { createPublicKey, createVerify } from 'node:crypto';\n\nfunction isValidInmobileWebhook(headers, rawBody, publicKeyBase64) {\n  const timestampText = headers['x-inmobile-request-timestamp'];\n  const timestamp = new Date(timestampText);\n\n  if (Number.isNaN(timestamp.getTime())) {\n    return false;\n  }\n\n  if ((Date.now() - timestamp.getTime()) > 5 * 60 * 1000) {\n    return false;\n  }\n\n  const bodyBuffer = Buffer.isBuffer(rawBody) ? rawBody : Buffer.from(rawBody, 'utf8');\n  const payload = Buffer.concat([\n    Buffer.from(headers['x-inmobile-request-id'], 'utf8'),\n    Buffer.from(timestampText, 'utf8'),\n    bodyBuffer\n  ]);\n  const publicKey = createPublicKey({\n    key: Buffer.from(publicKeyBase64, 'base64'),\n    format: 'der',\n    type: 'spki'\n  });\n\n  const verifier = createVerify('SHA256');\n  verifier.update(payload);\n  verifier.end();\n\n  return verifier.verify(publicKey, Buffer.from(headers['x-inmobile-signature'], 'base64'));\n}\n```\n",
    "version": "version 4"
  },
  "servers": [
    {
      "url": "https://api.inmobile.com"
    }
  ],
  "paths": {
    "/v4/blacklist": {
      "get": {
        "tags": [
          "Blacklist"
        ],
        "summary": "Get all blacklists",
        "description": "This response is a paged result and will contain the property '_links.next'.\nIf there are more pages, the next page in the paged result will be provided here.",
        "operationId": "Blacklist_GetAll",
        "parameters": [
          {
            "name": "pageLimit",
            "in": "query",
            "description": "How many records to return (must be between 1 and 250)",
            "schema": {
              "type": "integer",
              "format": "int32"
            },
            "x-position": 1
          }
        ],
        "responses": {
          "200": {
            "description": "A list of blacklists",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiPageModelOfBlacklistOutputApiModel"
                }
              }
            }
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      },
      "post": {
        "tags": [
          "Blacklist"
        ],
        "summary": "Create an entry in blacklist",
        "operationId": "Blacklist_Create",
        "requestBody": {
          "x-name": "blacklist",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/BlacklistCreateApiModel"
              }
            }
          },
          "required": true,
          "x-position": 1
        },
        "responses": {
          "200": {
            "description": "The created blacklist",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/BlacklistOutputApiModel"
                }
              }
            }
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "409": {
            "description": "Conflict",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      }
    },
    "/v4/blacklist/{blackListId}": {
      "get": {
        "tags": [
          "Blacklist"
        ],
        "summary": "Get entry by id",
        "operationId": "Blacklist_Get",
        "parameters": [
          {
            "name": "blackListId",
            "in": "path",
            "required": true,
            "description": "Id of the blacklist",
            "schema": {
              "type": "string",
              "format": "guid"
            },
            "x-position": 1
          }
        ],
        "responses": {
          "200": {
            "description": "A blacklist",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/BlacklistOutputApiModel"
                }
              }
            }
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      },
      "delete": {
        "tags": [
          "Blacklist"
        ],
        "summary": "Delete entry by id",
        "operationId": "Blacklist_Delete",
        "parameters": [
          {
            "name": "blackListId",
            "in": "path",
            "required": true,
            "description": "Id of the blacklist",
            "schema": {
              "type": "string",
              "format": "guid"
            },
            "x-position": 1
          }
        ],
        "responses": {
          "204": {
            "description": ""
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      }
    },
    "/v4/blacklist/ByNumber": {
      "get": {
        "tags": [
          "Blacklist"
        ],
        "summary": "Get entry by number",
        "operationId": "Blacklist_GetByNumber",
        "parameters": [
          {
            "name": "countryCode",
            "in": "query",
            "schema": {
              "type": "string"
            },
            "x-position": 1
          },
          {
            "name": "phoneNumber",
            "in": "query",
            "schema": {
              "type": "string"
            },
            "x-position": 2
          }
        ],
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/BlacklistOutputApiModel"
                }
              }
            }
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      },
      "delete": {
        "tags": [
          "Blacklist"
        ],
        "summary": "Delete entry by number",
        "operationId": "Blacklist_DeleteByNumber",
        "parameters": [
          {
            "name": "countryCode",
            "in": "query",
            "description": "The country code of the phone number",
            "schema": {
              "type": "string"
            },
            "x-position": 1
          },
          {
            "name": "phoneNumber",
            "in": "query",
            "description": "The phone number to delete from the blacklist",
            "schema": {
              "type": "string"
            },
            "x-position": 2
          }
        ],
        "responses": {
          "204": {
            "description": ""
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      }
    },
    "/v4/email/outgoing/sendusingtemplate": {
      "post": {
        "tags": [
          "Email - Outgoing"
        ],
        "summary": "Send an email using a template",
        "operationId": "EmailOutgoing_SendUsingTemplate",
        "requestBody": {
          "x-name": "request",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/EmailOutgoingTemplatePostRequest"
              }
            }
          },
          "required": true,
          "x-position": 1
        },
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/EmailOutgoingTemplatePostReply"
                }
              }
            }
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "409": {
            "description": "Conflict",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "503": {
            "description": "Service unavailable",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      }
    },
    "/v4/email/outgoing": {
      "post": {
        "tags": [
          "Email - Outgoing"
        ],
        "summary": "Send an email",
        "operationId": "EmailOutgoing_Send",
        "requestBody": {
          "x-name": "request",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/EmailOutgoingPostRequest"
              }
            }
          },
          "required": true,
          "x-position": 1
        },
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/EmailOutgoingBasePostReply"
                }
              }
            }
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "409": {
            "description": "Conflict",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "503": {
            "description": "Service unavailable",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      }
    },
    "/v4/email/outgoing/events": {
      "get": {
        "tags": [
          "Email - Outgoing"
        ],
        "summary": "Get email events",
        "description": "Each event will only be returned once. Once called, the event has been removed from our side and cannot be retrieved again using this method.",
        "operationId": "EmailOutgoing_GetEvents",
        "parameters": [
          {
            "name": "limit",
            "in": "query",
            "description": "How many events to return (must be between 1 and 250)",
            "schema": {
              "type": "integer",
              "format": "int32"
            },
            "x-position": 1
          }
        ],
        "responses": {
          "200": {
            "description": "A list of email events",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/EmailEventListModel"
                }
              }
            }
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      }
    },
    "/v4/email/templates": {
      "get": {
        "tags": [
          "Email - Templates"
        ],
        "summary": "Get all email templates",
        "description": "This response is a paged result and will contain the property '_links.next'.\nIf there are more pages, the next page in the paged result will be provided here.",
        "operationId": "EmailTemplates_GetAllEmailTemplates",
        "parameters": [
          {
            "name": "pageLimit",
            "in": "query",
            "description": "How many records to return (must be between 1 and 250)",
            "schema": {
              "type": "integer",
              "format": "int32"
            },
            "x-position": 1
          }
        ],
        "responses": {
          "200": {
            "description": "A list of email templates",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiPageModelOfEmailTemplateOutputApiModel"
                }
              }
            }
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      }
    },
    "/v4/email/templates/{id}": {
      "get": {
        "tags": [
          "Email - Templates"
        ],
        "summary": "Get email template by id",
        "operationId": "EmailTemplates_GetEmailTemplate",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            },
            "x-position": 1
          }
        ],
        "responses": {
          "200": {
            "description": "An email template",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/EmailTemplateOutputApiModel"
                }
              }
            }
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      }
    },
    "/v4/folders/{folderId}/files": {
      "post": {
        "tags": [
          "Files"
        ],
        "summary": "Upload file",
        "description": "A request must be less than 100mb.",
        "operationId": "Files_UploadJson",
        "parameters": [
          {
            "name": "folderId",
            "in": "path",
            "required": true,
            "description": "The ID of the folder to upload the file to",
            "schema": {
              "type": "string",
              "format": "guid"
            },
            "x-position": 1
          }
        ],
        "requestBody": {
          "x-name": "request",
          "description": "The file upload request",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/UploadApiFileModel"
              }
            }
          },
          "required": true,
          "x-position": 2
        },
        "responses": {
          "200": {
            "description": "An object that contains the ID and URL of the uploaded resource.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/UploadApiFileResponseModel"
                }
              }
            }
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "507": {
            "description": "Insufficient storage",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      },
      "get": {
        "tags": [
          "Files"
        ],
        "summary": "Get all files in a folder",
        "description": "This response is a paged result and will contain the property '_links.next'.\nIf there are more pages, the next page in the paged result will be provided here.",
        "operationId": "Files_GetAll",
        "parameters": [
          {
            "name": "folderId",
            "in": "path",
            "required": true,
            "description": "The ID of the folder to retrieve files from",
            "schema": {
              "type": "string",
              "format": "guid"
            },
            "x-position": 1
          },
          {
            "name": "pageLimit",
            "in": "query",
            "description": "How many records to return (must be between 1 and 250)",
            "schema": {
              "type": "integer",
              "format": "int32"
            },
            "x-position": 2
          }
        ],
        "responses": {
          "200": {
            "description": "A list of files",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiPageModelOfApiFileListModel"
                }
              }
            }
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      }
    },
    "/v4/folders/{folderId}/files/{fileId}": {
      "get": {
        "tags": [
          "Files"
        ],
        "summary": "Get file",
        "operationId": "Files_Get",
        "parameters": [
          {
            "name": "folderId",
            "in": "path",
            "required": true,
            "description": "The ID of the folder containing the file",
            "schema": {
              "type": "string",
              "format": "guid"
            },
            "x-position": 1
          },
          {
            "name": "fileId",
            "in": "path",
            "required": true,
            "description": "The ID of the file",
            "schema": {
              "type": "string",
              "format": "guid"
            },
            "x-position": 2
          }
        ],
        "responses": {
          "200": {
            "description": "The file",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiFileListModel"
                }
              }
            }
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      },
      "delete": {
        "tags": [
          "Files"
        ],
        "summary": "Delete file",
        "operationId": "Files_Delete",
        "parameters": [
          {
            "name": "folderId",
            "in": "path",
            "required": true,
            "description": "The ID of the folder containing the file",
            "schema": {
              "type": "string",
              "format": "guid"
            },
            "x-position": 1
          },
          {
            "name": "fileId",
            "in": "path",
            "required": true,
            "description": "The ID of the file",
            "schema": {
              "type": "string",
              "format": "guid"
            },
            "x-position": 2
          }
        ],
        "responses": {
          "204": {
            "description": ""
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "503": {
            "description": "Service unavailable",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      }
    },
    "/v4/folders": {
      "post": {
        "tags": [
          "Folders"
        ],
        "summary": "Create folder",
        "operationId": "Folders_CreateFolder",
        "requestBody": {
          "x-name": "folder",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/FolderInputApiModel"
              }
            }
          },
          "required": true,
          "x-position": 1
        },
        "responses": {
          "200": {
            "description": "The created folder",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/FolderOutputApiModel"
                }
              }
            }
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "409": {
            "description": "Conflict",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      },
      "get": {
        "tags": [
          "Folders"
        ],
        "summary": "Get all folders",
        "description": "This response is a paged result and will contain the property '_links.next'.\nIf there are more pages, the next page in the paged result will be provided here.",
        "operationId": "Folders_GetAll",
        "parameters": [
          {
            "name": "pageLimit",
            "in": "query",
            "schema": {
              "type": "integer",
              "format": "int32"
            },
            "x-position": 1
          }
        ],
        "responses": {
          "200": {
            "description": "A list of folders",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiPageModelOfFolderOutputApiModel"
                }
              }
            }
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      }
    },
    "/v4/folders/{folderId}": {
      "get": {
        "tags": [
          "Folders"
        ],
        "summary": "Get folder",
        "operationId": "Folders_Get",
        "parameters": [
          {
            "name": "folderId",
            "in": "path",
            "required": true,
            "description": "Id of the folder",
            "schema": {
              "type": "string",
              "format": "guid"
            },
            "x-position": 1
          }
        ],
        "responses": {
          "200": {
            "description": "The folder",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/FolderOutputApiModel"
                }
              }
            }
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      },
      "delete": {
        "tags": [
          "Folders"
        ],
        "summary": "Delete folder",
        "description": "The folder must be empty before it can be deleted.",
        "operationId": "Folders_DeleteFolder",
        "parameters": [
          {
            "name": "folderId",
            "in": "path",
            "required": true,
            "description": "Id of the folder",
            "schema": {
              "type": "string",
              "format": "guid"
            },
            "x-position": 1
          }
        ],
        "responses": {
          "204": {
            "description": ""
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "409": {
            "description": "Conflict",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      }
    },
    "/v4/sms/gdpr/deletionrequests": {
      "post": {
        "tags": [
          "Gdpr"
        ],
        "summary": "Create information Deletion Request",
        "operationId": "Gdpr_DeletionRequests",
        "requestBody": {
          "x-name": "deletionRequest",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/DeletionRequestCreateInfo"
              }
            }
          },
          "required": true,
          "x-position": 1
        },
        "responses": {
          "200": {
            "description": "The created information Deletion Request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/RequestDeletionOutputApiModel"
                }
              }
            }
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      }
    },
    "/v4/lists": {
      "get": {
        "tags": [
          "Lists"
        ],
        "summary": "Get all lists",
        "description": "This response is a paged result and will contain the property '_links.next'.\nIf there are more pages, the next page in the paged result will be provided here.",
        "operationId": "Lists_GetAllLists",
        "parameters": [
          {
            "name": "pageLimit",
            "in": "query",
            "description": "How many records to return (must be between 1 and 250)",
            "schema": {
              "type": "integer",
              "format": "int32"
            },
            "x-position": 1
          }
        ],
        "responses": {
          "200": {
            "description": "A list of lists",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiPageModelOfGroupOutputApiModel"
                }
              }
            }
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      },
      "post": {
        "tags": [
          "Lists"
        ],
        "summary": "Create list",
        "operationId": "Lists_CreateList",
        "requestBody": {
          "x-name": "list",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/GroupInputApiModel"
              }
            }
          },
          "required": true,
          "x-position": 1
        },
        "responses": {
          "200": {
            "description": "The created list",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/GroupOutputApiModel"
                }
              }
            }
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      }
    },
    "/v4/lists/{listId}": {
      "get": {
        "tags": [
          "Lists"
        ],
        "summary": "Get list",
        "operationId": "Lists_GetList",
        "parameters": [
          {
            "name": "listId",
            "in": "path",
            "required": true,
            "description": "Id of the list",
            "schema": {
              "type": "string",
              "format": "guid"
            },
            "x-position": 1
          }
        ],
        "responses": {
          "200": {
            "description": "A list",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/GroupOutputApiModel"
                }
              }
            }
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      },
      "delete": {
        "tags": [
          "Lists"
        ],
        "summary": "Delete list",
        "operationId": "Lists_DeleteList",
        "parameters": [
          {
            "name": "listId",
            "in": "path",
            "required": true,
            "description": "Id of the list",
            "schema": {
              "type": "string",
              "format": "guid"
            },
            "x-position": 1
          }
        ],
        "responses": {
          "204": {
            "description": ""
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      },
      "put": {
        "tags": [
          "Lists"
        ],
        "summary": "Update list",
        "operationId": "Lists_UpdateList",
        "parameters": [
          {
            "name": "listId",
            "in": "path",
            "required": true,
            "description": "The id of the list",
            "schema": {
              "type": "string",
              "format": "guid"
            },
            "x-position": 1
          }
        ],
        "requestBody": {
          "x-name": "list",
          "description": "The list object",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/GroupInputApiModel"
              }
            }
          },
          "required": true,
          "x-position": 2
        },
        "responses": {
          "200": {
            "description": "The updated list",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/GroupOutputApiModel"
                }
              }
            }
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      }
    },
    "/v4/lists/{listId}/recipients": {
      "get": {
        "tags": [
          "Lists"
        ],
        "summary": "Get all recipients in a list",
        "description": "This response is a paged result and will contain the property '_links.next'.\nIf there are more pages, the next page in the paged result will be provided here.",
        "operationId": "Lists_GetAllRecipient",
        "parameters": [
          {
            "name": "listId",
            "in": "path",
            "required": true,
            "description": "Id of the list",
            "schema": {
              "type": "string",
              "format": "guid"
            },
            "x-position": 1
          },
          {
            "name": "pageLimit",
            "in": "query",
            "description": "How many records to return (must be between 1 and 250)",
            "schema": {
              "type": "integer",
              "format": "int32"
            },
            "x-position": 2
          }
        ],
        "responses": {
          "200": {
            "description": "A list of recipients",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiPageModelOfRecipientOutputApiModel"
                }
              }
            }
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      },
      "post": {
        "tags": [
          "Lists"
        ],
        "summary": "Create recipient",
        "operationId": "Lists_CreateRecipient",
        "parameters": [
          {
            "name": "listId",
            "in": "path",
            "required": true,
            "description": "Id of the list",
            "schema": {
              "type": "string",
              "format": "guid"
            },
            "x-position": 1
          }
        ],
        "requestBody": {
          "x-name": "recipient",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/RecipientCreateApiModel"
              }
            }
          },
          "required": true,
          "x-position": 2
        },
        "responses": {
          "200": {
            "description": "The created recipient",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/RecipientOutputApiModel"
                }
              }
            }
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "409": {
            "description": "Conflict",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      }
    },
    "/v4/lists/{listId}/recipients/all": {
      "delete": {
        "tags": [
          "Lists"
        ],
        "summary": "Deletes all recipients from a list",
        "operationId": "Lists_DeleteAllRecipients",
        "parameters": [
          {
            "name": "listId",
            "in": "path",
            "required": true,
            "description": "Id of the list",
            "schema": {
              "type": "string",
              "format": "guid"
            },
            "x-position": 1
          }
        ],
        "responses": {
          "204": {
            "description": "The affected count"
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      }
    },
    "/v4/lists/{listId}/recipients/{recipientId}": {
      "get": {
        "tags": [
          "Lists"
        ],
        "summary": "Get recipient by id",
        "operationId": "Lists_GetRecipient",
        "parameters": [
          {
            "name": "listId",
            "in": "path",
            "required": true,
            "description": "Id of the list",
            "schema": {
              "type": "string",
              "format": "guid"
            },
            "x-position": 1
          },
          {
            "name": "recipientId",
            "in": "path",
            "required": true,
            "description": "Id of the recipient",
            "schema": {
              "type": "string",
              "format": "guid"
            },
            "x-position": 2
          }
        ],
        "responses": {
          "200": {
            "description": "A recipient",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/RecipientOutputApiModel"
                }
              }
            }
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      },
      "delete": {
        "tags": [
          "Lists"
        ],
        "summary": "Delete recipient by id",
        "operationId": "Lists_DeleteRecipient",
        "parameters": [
          {
            "name": "listId",
            "in": "path",
            "required": true,
            "description": "Id of the list",
            "schema": {
              "type": "string",
              "format": "guid"
            },
            "x-position": 1
          },
          {
            "name": "recipientId",
            "in": "path",
            "required": true,
            "description": "Id of the recipient",
            "schema": {
              "type": "string",
              "format": "guid"
            },
            "x-position": 2
          }
        ],
        "responses": {
          "204": {
            "description": ""
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      },
      "put": {
        "tags": [
          "Lists"
        ],
        "summary": "Update recipient",
        "description": "Only mentioned fields are updated, e.g. leave out fields[\"email\"] if you do not want to update this field. On the other hand, set fields[\"email\"] = null in case you want to erase the existing value.",
        "operationId": "Lists_UpdateRecipient",
        "parameters": [
          {
            "name": "listId",
            "in": "path",
            "required": true,
            "description": "Id of the list",
            "schema": {
              "type": "string",
              "format": "guid"
            },
            "x-position": 1
          },
          {
            "name": "recipientId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "guid"
            },
            "x-position": 2
          }
        ],
        "requestBody": {
          "x-name": "recipient",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/RecipientUpdateApiModel"
              }
            }
          },
          "required": true,
          "x-position": 3
        },
        "responses": {
          "200": {
            "description": "The updated recipient",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/RecipientOutputApiModel"
                }
              }
            }
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "409": {
            "description": "Conflict",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      }
    },
    "/v4/lists/{listId}/recipients/ByNumber": {
      "get": {
        "tags": [
          "Lists"
        ],
        "summary": "Get recipient by number",
        "operationId": "Lists_GetRecipientByNumber",
        "parameters": [
          {
            "name": "listId",
            "in": "path",
            "required": true,
            "description": "Id of the list",
            "schema": {
              "type": "string",
              "format": "guid"
            },
            "x-position": 1
          },
          {
            "name": "countryCode",
            "in": "query",
            "description": "Target countryCode",
            "schema": {
              "type": "string"
            },
            "x-position": 2
          },
          {
            "name": "phoneNumber",
            "in": "query",
            "description": "Target phoneNumber",
            "schema": {
              "type": "string"
            },
            "x-position": 3
          }
        ],
        "responses": {
          "200": {
            "description": "A recipient",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/RecipientOutputApiModel"
                }
              }
            }
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      },
      "delete": {
        "tags": [
          "Lists"
        ],
        "summary": "Delete recipient by number",
        "operationId": "Lists_DeleteRecipientByNumber",
        "parameters": [
          {
            "name": "listId",
            "in": "path",
            "required": true,
            "description": "Id of the list",
            "schema": {
              "type": "string",
              "format": "guid"
            },
            "x-position": 1
          },
          {
            "name": "countryCode",
            "in": "query",
            "description": "Target countryCode",
            "schema": {
              "type": "string"
            },
            "x-position": 2
          },
          {
            "name": "phoneNumber",
            "in": "query",
            "description": "Target phoneNumber",
            "schema": {
              "type": "string"
            },
            "x-position": 3
          }
        ],
        "responses": {
          "204": {
            "description": ""
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      },
      "post": {
        "tags": [
          "Lists"
        ],
        "summary": "Create or update recipient by number",
        "operationId": "Lists_CreateOrUpdateRecipientByNumber",
        "parameters": [
          {
            "name": "listId",
            "in": "path",
            "required": true,
            "description": "Id of the list",
            "schema": {
              "type": "string",
              "format": "guid"
            },
            "x-position": 1
          },
          {
            "name": "countryCode",
            "in": "query",
            "description": "Target countryCode",
            "schema": {
              "type": "string"
            },
            "x-position": 2
          },
          {
            "name": "phoneNumber",
            "in": "query",
            "description": "Target phoneNumber",
            "schema": {
              "type": "string"
            },
            "x-position": 3
          }
        ],
        "requestBody": {
          "x-name": "recipient",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/RecipientCreateOrUpdateApiModel"
              }
            }
          },
          "required": true,
          "x-position": 4
        },
        "responses": {
          "200": {
            "description": "The created or updated recipient",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/RecipientOutputApiModel"
                }
              }
            }
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      }
    },
    "/v4/rcs/agents": {
      "get": {
        "tags": [
          "RCS - Agents"
        ],
        "summary": "Get all RCS agents",
        "description": "This response is a paged result and will contain the property '_links.next'.</br>\nIf there are more pages, the next page in the paged result will be provided here.",
        "operationId": "RcsAgents_GetAll",
        "parameters": [
          {
            "name": "pageLimit",
            "in": "query",
            "description": "How many records to return (must be between 1 and 250)",
            "schema": {
              "type": "integer",
              "format": "int32"
            },
            "x-position": 1
          }
        ],
        "responses": {
          "200": {
            "description": "A list of RCS agents",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiPageModelOfRcsAgentGetAllApiModel"
                }
              }
            }
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      }
    },
    "/v4/rcs/agents/{rcsAgentId}": {
      "post": {
        "tags": [
          "RCS - Agents"
        ],
        "summary": "Update RCS agent",
        "operationId": "RcsAgents_Update",
        "parameters": [
          {
            "name": "rcsAgentId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "guid"
            },
            "x-position": 1
          }
        ],
        "requestBody": {
          "x-name": "request",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/RcsAgentUpdateRequestApiModel"
              }
            }
          },
          "required": true,
          "x-position": 2
        },
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/RcsAgentUpdateResponseApiModel"
                }
              }
            }
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Not found",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        },
        "callbacks": {
          "events": {
            "https://[your_domain]/your/desired/path/typing/events": {
              "post": {
                "summary": "Typing callback url (Webhook)",
                "description": "The callback url to receive typing information on when end users are typing to an agent.\nThis is a call done by us to you and the url to be called\nThe payload may be extended with more properties in the future. We do not consider it a breaking change to add properties",
                "requestBody": {
                  "x-name": "payload",
                  "content": {
                    "application/json": {
                      "schema": {
                        "$ref": "#/components/schemas/RcsAgentEventListModelOfRcsTypingCallbackModel"
                      }
                    }
                  },
                  "required": true,
                  "x-position": 1
                },
                "responses": {
                  "200": {
                    "description": ""
                  }
                }
              }
            }
          }
        }
      }
    },
    "/v4/rcs/capabilities": {
      "post": {
        "tags": [
          "RCS - Capabilities"
        ],
        "summary": "Get RCS capabilities",
        "description": "Get RCS capabilities for the provided MSISDNs for a specific agent.</br>\nThis endpoint relies on Google for up-to-date capability information, so response times can be slower than on other endpoints.</br>\nOne or more MSISDNs can return a transient error.</br>\nWhen that happens, <c>rcsSupport.value</c> is <c>3 = TransientError</c>.</br>\nWe recommend waiting a few minutes before retrying the affected entries.</br>\nIf <c>rcsSupport.value</c> is <c>2 = SupportsRcs</c> and <c>featuresSupported</c> is empty, Google did not report any explicit supported features for that MSISDN, and only text-based RCS messages are supported.",
        "operationId": "RcsCapabilities_Post",
        "requestBody": {
          "x-name": "request",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/RcsCapabilitiesPostRequest"
              }
            }
          },
          "required": true,
          "x-position": 1
        },
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/RcsCapabilitiesPostReply"
                }
              }
            }
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      }
    },
    "/v4/rcs/incoming/messages": {
      "get": {
        "tags": [
          "RCS - Incoming"
        ],
        "summary": "Get incoming RCS messages",
        "description": "Each message will only be returned once. Once called, the message has been marked as read from our side and cannot be retrieved again using this method.",
        "operationId": "RcsIncoming_GetMessages",
        "parameters": [
          {
            "name": "limit",
            "in": "query",
            "description": "How many records to return (must be between 1 and 250)",
            "schema": {
              "type": "integer",
              "format": "int32"
            },
            "x-position": 1
          }
        ],
        "responses": {
          "200": {
            "description": "A list of messages",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/IncomingRcsMessageListApiModel"
                }
              }
            }
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        }
      }
    },
    "/v4/rcs/outgoing/text": {
      "post": {
        "tags": [
          "RCS - Outgoing"
        ],
        "summary": "Send RCS text only messages",
        "operationId": "RcsOutgoing_Create",
        "requestBody": {
          "x-name": "request",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/RcsOutgoingCreatePostRequestOfRcsOutgoingCreateTextMessageModel"
              },
              "examples": {
                "replyDialUrlAndLocation": {
                  "summary": "Reply, dial, URL, and location suggestions",
                  "description": "Shows a suggested reply plus dial, open URL, and view location suggested actions.",
                  "value": {
                    "messages": [
                      {
                        "to": "4512345678",
                        "countryHint": "45",
                        "agentId": "65a53287-862b-44dd-afed-0e7aef22a688",
                        "messageTrafficType": 3,
                        "messageId": "PetShop",
                        "respectBlacklist": true,
                        "validityPeriodInSeconds": 90,
                        "msisdnCooldownInMinutes": 1440,
                        "suggestions": [
                          {
                            "reply": {
                              "text": "Yes",
                              "postbackData": "WUVTX1NFTEVDVEVE"
                            }
                          },
                          {
                            "action": {
                              "text": "Call us",
                              "postbackData": "Q0FMTF9TRUxFQ1RFRA==",
                              "dialAction": {
                                "to": "4512345678",
                                "countryHint": "45"
                              }
                            }
                          },
                          {
                            "action": {
                              "text": "Open website",
                              "postbackData": "T1BFTl9XRUJTSVRF",
                              "openUrlAction": {
                                "url": "https://www.inmobile.com",
                                "application": 1
                              }
                            }
                          },
                          {
                            "action": {
                              "text": "Show location",
                              "postbackData": "U0hPV19MT0NBVElPTg==",
                              "viewLocationAction": {
                                "latitude": 55.6761,
                                "longitude": 12.5683
                              }
                            }
                          }
                        ],
                        "webhooks": {
                          "statusCallbackUrl": "https://[your_domain]/your/desired/path",
                          "readCallbackUrl": "https://[your_domain]/your/desired/path"
                        },
                        "text": "This is a message text to be sent"
                      }
                    ]
                  }
                },
                "calendarAndShareLocation": {
                  "summary": "Calendar and share location suggestions",
                  "description": "Shows create calendar event and share location suggested actions.",
                  "value": {
                    "messages": [
                      {
                        "to": "4512345678",
                        "countryHint": "45",
                        "agentId": "65a53287-862b-44dd-afed-0e7aef22a688",
                        "messageTrafficType": 3,
                        "messageId": "PetShop",
                        "respectBlacklist": true,
                        "validityPeriodInSeconds": 90,
                        "msisdnCooldownInMinutes": 1440,
                        "suggestions": [
                          {
                            "reply": {
                              "text": "Remind me",
                              "postbackData": "UkVNSU5EX01FX1NFTEVDVEVE"
                            }
                          },
                          {
                            "action": {
                              "text": "Add event",
                              "postbackData": "QUREX0VWRU5U",
                              "createCalendarEventAction": {
                                "startTime": "2026-06-24T14:00:00Z",
                                "endTime": "2026-06-24T15:00:00Z",
                                "title": "Meeting",
                                "description": "Remember meeting"
                              }
                            }
                          },
                          {
                            "action": {
                              "text": "Share location",
                              "postbackData": "U0hBUkVfTE9DQVRJT04=",
                              "shareLocationAction": {}
                            }
                          }
                        ],
                        "webhooks": {
                          "statusCallbackUrl": "https://[your_domain]/your/desired/path",
                          "readCallbackUrl": "https://[your_domain]/your/desired/path"
                        },
                        "text": "This is a message text to be sent"
                      }
                    ]
                  }
                }
              }
            }
          },
          "required": true,
          "x-position": 1
        },
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/RcsOutgoingCreatePostReply"
                }
              }
            }
          },
          "400": {
            "description": "Bad request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "Unauthorized",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "409": {
            "description": "Conflict",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ApiErrorMessage"
                }
              }
            }
          }
        },
        "callbacks": {
          "events": {
            "https://[your_domain]/your/desired/path/read/events": {
              "post": {
                "summary": "Read events callback url (Webhook)",
[...]
